import {
  Controller,
  Post,
  Delete,
  Route,
  Security,
  Tags,
  Body,
  Path,
  Request,
  Get,
  Patch,
} from "tsoa";
import HttpError from "../interfaces/http-error";
import HttpStatus from "../interfaces/http-status";
import HttpSuccess from "../interfaces/http-success";
import { AppDataSource } from "../database/data-source";
import {
  CreateProfileEmployeeAssessment,
  ProfileAssessment,
  UpdateProfileAssessment,
} from "../entities/ProfileAssessment";
import { ProfileAssessmentHistory } from "../entities/ProfileAssessmentHistory";
import { ProfileEmployee } from "../entities/ProfileEmployee";
import { RequestWithUser } from "../middlewares/user";
import permission from "../interfaces/permission";
import { setLogDataDiff } from "../interfaces/utils";
@Route("api/v1/org/profile-employee/assessments")
@Tags("ProfileEmployeeAssessments")
@Security("bearerAuth")
export class ProfileAssessmentsEmployeeController extends Controller {
  private profileEmployeeRepo = AppDataSource.getRepository(ProfileEmployee);
  private profileAssessmentsRepository = AppDataSource.getRepository(ProfileAssessment);
  private profileAssessmentsHistoryRepository =
    AppDataSource.getRepository(ProfileAssessmentHistory);

  @Get("user")
  public async detailProfileAssessmentsUser(@Request() request: { user: Record<string, any> }) {
    const profile = await this.profileEmployeeRepo.findOneBy({ keycloak: request.user.sub });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    const getProfileAssessments = await this.profileAssessmentsRepository.find({
      where: { profileEmployeeId: profile.id, isDeleted: false },
      order: { createdAt: "ASC" },
    });
    if (!getProfileAssessments) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileAssessments);
  }

  @Get("{profileEmployeeId}")
  public async detailProfileAssessments(
    @Path() profileEmployeeId: string,
    @Request() req: RequestWithUser,
  ) {
    let _workflow = await new permission().Workflow(req, profileEmployeeId, "SYS_REGISTRY_EMP");
    if (_workflow == false)
      await new permission().PermissionOrgUserGet(req, "SYS_REGISTRY_EMP", profileEmployeeId);
    const getProfileAssessments = await this.profileAssessmentsRepository.find({
      where: {
        profileEmployeeId: profileEmployeeId,
        isDeleted: false
      },
      order: { createdAt: "ASC" },
    });
    if (!getProfileAssessments) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }
    return new HttpSuccess(getProfileAssessments);
  }

  @Get("admin/history/{assessmentId}")
  public async getProfileAdminAssessmentsHistory(
    @Path() assessmentId: string,
    @Request() req: RequestWithUser,
  ) {
    const _record = await this.profileAssessmentsRepository.findOneBy({ id: assessmentId });
    if (_record) {
      let _workflow = await new permission().Workflow(req, assessmentId, "SYS_REGISTRY_EMP");
      if (_workflow == false)
        await new permission().PermissionOrgUserGet(
          req,
          "SYS_REGISTRY_EMP",
          _record.profileEmployeeId,
        );
    }
    const record = await this.profileAssessmentsHistoryRepository.find({
      where: {
        profileAssessmentId: assessmentId,
      },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess(record);
  }

  @Get("history/{assessmentId}")
  public async getProfileAssessmentsHistory(@Path() assessmentId: string) {
    const record = await this.profileAssessmentsHistoryRepository.find({
      where: {
        profileAssessmentId: assessmentId,
      },
      order: { createdAt: "DESC" },
    });
    if (!record) {
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    }

    return new HttpSuccess(record);
  }

  @Post()
  public async profileAssessment(
    @Request() req: RequestWithUser,
    @Body() body: CreateProfileEmployeeAssessment,
  ) {
    if (!body.profileEmployeeId) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "กรุณากรอก profileEmployeeId");
    }

    const profile = await this.profileEmployeeRepo.findOneBy({ id: body.profileEmployeeId });
    if (!profile) {
      throw new HttpError(HttpStatus.BAD_REQUEST, "ไม่พบ profile ดังกล่าว");
    }
    await new permission().PermissionOrgUserUpdate(req, "SYS_REGISTRY_EMP", profile.id);
    const before = null;
    const data = new ProfileAssessment();
    const meta = {
      createdUserId: req.user.sub,
      createdFullName: req.user.name,
      lastUpdateUserId: req.user.sub,
      lastUpdateFullName: req.user.name,
      createdAt: new Date(),
      lastUpdatedAt: new Date(),
    };
    Object.assign(data, { ...body, ...meta });
    const history = new ProfileAssessmentHistory();
    Object.assign(history, { ...data, id: undefined });

    await this.profileAssessmentsRepository.save(data, { data: req });
    setLogDataDiff(req, { before, after: data });
    history.profileAssessmentId = data.id;
    await this.profileAssessmentsHistoryRepository.save(history, { data: req });
    setLogDataDiff(req, { before, after: history });

    return new HttpSuccess(data.id);
  }

  @Patch("{assessmentId}")
  public async editProfileAssessment(
    @Body() body: UpdateProfileAssessment,
    @Request() req: RequestWithUser,
    @Path() assessmentId: string,
  ) {
    const record = await this.profileAssessmentsRepository.findOneBy({ id: assessmentId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    await new permission().PermissionOrgUserUpdate(
      req,
      "SYS_REGISTRY_EMP",
      record.profileEmployeeId,
    );

    const before = structuredClone(record);
    // const before_null = null;
    const history = new ProfileAssessmentHistory();

    Object.assign(record, body);
    Object.assign(history, { ...record, id: undefined });

    history.profileAssessmentId = assessmentId;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = new Date();
    history.lastUpdateUserId = req.user.sub;
    history.lastUpdateFullName = req.user.name;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = new Date();
    history.lastUpdatedAt = new Date();

    await Promise.all([
      this.profileAssessmentsRepository.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.profileAssessmentsHistoryRepository.save(history, { data: req }),
      // setLogDataDiff(req, { before: before_null, after: history }),
    ]);

    return new HttpSuccess();
  }

  /**
   * API ลบข้อมูลผลการประเมินการปฏิบัติราชการ
   * @summary API ลบข้อมูลผลการประเมินการปฏิบัติราชการ
   * @param assessmentId คีย์ผลการประเมินการปฏิบัติราชการ
   */
  @Patch("update-delete/{assessmentId}")
  public async updateIsDeleted(
    @Request() req: RequestWithUser,
    @Path() assessmentId: string,
  ) {
    const record = await this.profileAssessmentsRepository.findOneBy({ id: assessmentId });
    if (!record) throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");
    if (record.isDeleted === true) {
      return new HttpSuccess();
    }
    await new permission().PermissionOrgUserDelete(req, "SYS_REGISTRY_EMP", record.profileEmployeeId);
    const before = structuredClone(record);
    const history = new ProfileAssessmentHistory();
    const now = new Date();
    record.isDeleted = true;
    record.lastUpdateUserId = req.user.sub;
    record.lastUpdateFullName = req.user.name;
    record.lastUpdatedAt = now;

    Object.assign(history, { ...record, id: undefined });
    history.profileAssessmentId = assessmentId;
    history.createdUserId = req.user.sub;
    history.createdFullName = req.user.name;
    history.createdAt = now;

    await Promise.all([
      this.profileAssessmentsRepository.save(record, { data: req }),
      setLogDataDiff(req, { before, after: record }),
      this.profileAssessmentsHistoryRepository.save(history, { data: req }),
    ]);

    return new HttpSuccess();
  }

  @Delete("{assessmentId}")
  public async deleteProfileAssessment(
    @Path() assessmentId: string,
    @Request() req: RequestWithUser,
  ) {
    const _record = await this.profileAssessmentsRepository.findOneBy({ id: assessmentId });
    if (_record) {
      await new permission().PermissionOrgUserDelete(
        req,
        "SYS_REGISTRY_EMP",
        _record.profileEmployeeId,
      );
    }
    await this.profileAssessmentsHistoryRepository.delete({
      profileAssessmentId: assessmentId,
    });

    const result = await this.profileAssessmentsRepository.delete({ id: assessmentId });

    if (result.affected == undefined || result.affected <= 0)
      throw new HttpError(HttpStatus.NOT_FOUND, "ไม่พบข้อมูล");

    return new HttpSuccess();
  }
}
